## golang-github-checkpoint-restore-go-criu 5.3.0

=== crit-go/magic-gen/Makefile ===
GO ?= go
CC ?= gcc

all: build test magicgen

build:
	 @$(GO) build -v

test/magicgen: build
	echo "#define TEST_MAGIC 0x12345678" > test_input
	@rm -f test_output
	./magic-gen test_input test_output
	cmp samplemagic test_output
	if [ $$? -eq 0 ]; then \
		echo PASS; \
		exit 0; \
	else \
		echo FAIL; \
		exit 1; \
	fi
	@rm -f test_input test_output

test: test/magicgen

magic.h:
	curl -s https://raw.githubusercontent.com/checkpoint-restore/criu/criu-dev/criu/include/magic.h -o magic.h

magicgen: build magic.h
	./magic-gen magic.h magic.json
	@rm -f magic.h

clean:
	@rm -f testmagic.json
	@rm -f test_output

.PHONY: build test clean magicgen

## golang-github-checkpoint-restore-go-criu 3.11

=== debian/changelog ===
golang-github-checkpoint-restore-go-criu (3.11-2) unstable; urgency=medium

  * Standards-Version: 4.5.0.

 -- Dmitry Smirnov <onlyjob@debian.org>  Sun, 26 Jan 2020 20:17:42 +1100

golang-github-checkpoint-restore-go-criu (3.11-1) unstable; urgency=medium

  * Initial release (Closes: #948113).

 -- Dmitry Smirnov <onlyjob@debian.org>  Sat, 04 Jan 2020 17:35:35 +1100

=== debian/control ===
Source: golang-github-checkpoint-restore-go-criu
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders:
 Dmitry Smirnov <onlyjob@debian.org>,
Section: devel
Testsuite: autopkgtest-pkg-go
Priority: optional
Build-Depends:
 debhelper-compat (= 12),
 dh-golang,
 protobuf-compiler,
   golang-goprotobuf-dev (>= 1.3.2~),
Build-Depends-Indep:
 golang-any,
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-github-checkpoint-restore-go-criu
Vcs-Git: https://salsa.debian.org/go-team/packages/golang-github-checkpoint-restore-go-criu.git
Homepage: https://github.com/checkpoint-restore/go-criu
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/checkpoint-restore/go-criu

Package: golang-github-checkpoint-restore-go-criu-dev
Architecture: all
Depends: ${misc:Depends}
Description: CRIU bindings for Golang
 Golang bindings for CRIU. The code is based on the Golang-based PHaul
 implementation from the CRIU repository.
 .
 Golang bindings provide an easy way to use the CRIU RPC calls from Golang
 without the need to set up all the infrastructure to make the actual RPC
 connection to CRIU.

=== debian/rules ===
#!/usr/bin/make -f

PBGO   := rpc/rpc.pb.go stats/stats.pb.go
PBGO_S := rpc/rpc.proto stats/stats.proto

%:
	dh $@ --builddirectory=_build --buildsystem=golang --with=golang

$(PBGO):
	cp -rv debian/missing-sources/* ./
	protoc --go_out=. $(@:.pb.go=.proto)

override_dh_clean:
	dh_clean $(PBGO) $(PBGO_S) */*.URL

override_dh_auto_configure: $(PBGO)
	dh_auto_configure

## golang-github-checkpoint-restore-go-criu 4.1.0

=== debian/changelog ===
golang-github-checkpoint-restore-go-criu (4.1.0-3) unstable; urgency=medium

  * Team upload.

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

  [ Shengjing Zhu ]
  * Remove test directory manually in dh_configure (Closes: #971197)

 -- Shengjing Zhu <zhsj@debian.org>  Sun, 04 Oct 2020 16:25:43 +0800

golang-github-checkpoint-restore-go-criu (4.1.0-2) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.

 -- Shengjing Zhu <zhsj@debian.org>  Sun, 23 Aug 2020 00:45:08 +0800

golang-github-checkpoint-restore-go-criu (4.1.0-1) experimental; urgency=medium

  * Team upload.
  * New upstream version 4.1.0
  * Bump debhelper-compat to 13
  * Remove unused Files-Excluded in d/copyright
  * Exclude main package when building
  * Update proto defines from criu 3.14

 -- Shengjing Zhu <zhsj@debian.org>  Mon, 17 Aug 2020 23:30:59 +0800

=== debian/control ===
--- 
+++ 
@@ -6,10 +6,10 @@
 Testsuite: autopkgtest-pkg-go
 Priority: optional
 Build-Depends:
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  dh-golang,
+ golang-goprotobuf-dev (>= 1.3.2~),
  protobuf-compiler,
-   golang-goprotobuf-dev (>= 1.3.2~),
 Build-Depends-Indep:
  golang-any,
 Standards-Version: 4.5.0
@@ -21,7 +21,8 @@
 
 Package: golang-github-checkpoint-restore-go-criu-dev
 Architecture: all
-Depends: ${misc:Depends}
+Depends:
+ ${misc:Depends},
 Description: CRIU bindings for Golang
  Golang bindings for CRIU. The code is based on the Golang-based PHaul
  implementation from the CRIU repository.

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,6 @@
 #!/usr/bin/make -f
+
+export DH_GOLANG_EXCLUDES := crit-go/magic-gen
 
 PBGO   := rpc/rpc.pb.go stats/stats.pb.go
 PBGO_S := rpc/rpc.proto stats/stats.proto
@@ -15,3 +17,6 @@
 
 override_dh_auto_configure: $(PBGO)
 	dh_auto_configure
+	# remove test dir manually, this dir will cause `go list` failed
+	# C source files not allowed when not using cgo or SWIG: piggie.c
+	rm -rvf _build/src/github.com/checkpoint-restore/go-criu/test/

=== debian/watch ===
# https://salsa.debian.org/snippets/95
# uscan(1) configuration file.
version=4

opts="\
pgpmode=none,\
repack,compression=xz,repacksuffix=+dfsg,\
dversionmangle=s{[+~]dfsg\d*}{},\
" https://github.com/checkpoint-restore/go-criu/releases \
  .*/archive/v?(\d[\d\.]+)\.tar\.gz

## golang-github-checkpoint-restore-go-criu 5.1.0

=== debian/changelog ===
golang-github-checkpoint-restore-go-criu (5.1.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 5.1.0 (Closes: #993317)

 -- Shengjing Zhu <zhsj@debian.org>  Mon, 11 Oct 2021 00:44:02 +0800

=== debian/control ===
--- 
+++ 
@@ -8,11 +8,11 @@
 Build-Depends:
  debhelper-compat (= 13),
  dh-golang,
- golang-goprotobuf-dev (>= 1.3.2~),
- protobuf-compiler,
+ golang-google-protobuf-dev,
+ protoc-gen-go,
 Build-Depends-Indep:
  golang-any,
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-github-checkpoint-restore-go-criu
 Vcs-Git: https://salsa.debian.org/go-team/packages/golang-github-checkpoint-restore-go-criu.git
 Homepage: https://github.com/checkpoint-restore/go-criu
@@ -22,7 +22,10 @@
 Package: golang-github-checkpoint-restore-go-criu-dev
 Architecture: all
 Depends:
+ golang-google-protobuf-dev,
  ${misc:Depends},
+Breaks:
+ golang-github-opencontainers-runc-dev (<< 1.0.2+ds1-1~),
 Description: CRIU bindings for Golang
  Golang bindings for CRIU. The code is based on the Golang-based PHaul
  implementation from the CRIU repository.

## golang-github-checkpoint-restore-go-criu 5.3.0

=== debian/changelog ===
golang-github-checkpoint-restore-go-criu (5.3.0-2) unstable; urgency=medium

  * Team upload.
  * upload to unstable

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 06 Mar 2022 17:34:36 -0500

golang-github-checkpoint-restore-go-criu (5.3.0-1) experimental; urgency=medium

  * Team upload.
  * New upstream version 5.3.0

 -- Reinhard Tartler <siretart@tauware.de>  Wed, 16 Feb 2022 19:00:23 -0500

=== debian/rules ===
#!/usr/bin/make -f

export DH_GOLANG_EXCLUDES := crit-go/magic-gen phaul test

SRC_DIR = _build/src/github.com/checkpoint-restore/go-criu/

%:
	dh $@ --builddirectory=_build --buildsystem=golang --with=golang

execute_after_dh_auto_configure:
	cp debian/missing-sources/stats/stats.proto $(SRC_DIR)stats/
	$(RM) $(addprefix $(SRC_DIR),rpc/rpc.pb.go stats/stats.pb.go)
	cd $(SRC_DIR) && protoc --go_out=. --go_opt=Mrpc/rpc.proto=rpc/ rpc/rpc.proto
	cd $(SRC_DIR) && protoc --go_out=. --go_opt=Mstats/stats.proto=stats/ stats/stats.proto

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none" \
  https://github.com/checkpoint-restore/go-criu \
  refs/tags/v?@ANY_VERSION@ debian

## golang-github-checkpoint-restore-go-criu 6.3.0%2Bds1

=== debian/changelog ===
golang-github-checkpoint-restore-go-criu (6.3.0+ds1-2) unstable; urgency=medium

  * Upload to unstable

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 24 Oct 2023 18:08:53 -0400

golang-github-checkpoint-restore-go-criu (6.3.0+ds1-1) experimental; urgency=medium

  [ Reinhard Tartler ]
  * debian/watch: mangle version number
  * New upstream version 6.3.0+ds1
  * Bump Standards Version
  * debian/control: Use more appropriate archive section 'golang'
  * take away spurious +x bits
  * Add myself to uploaders
  
  [ Debian Janitor ]
  * Apply multi-arch hints:
    + golang-github-checkpoint-restore-go-criu-dev: Add Multi-Arch: foreign.

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 14 Jan 2023 14:30:11 -0500

## golang-github-checkpoint-restore-go-criu 6.3.0+ds1

=== scripts/Makefile ===
GO ?= go

magic-gen: clean magic.h
	$(GO) run magicgen.go magic.h ../magic/magic.go

magic.h:
	curl -s https://raw.githubusercontent.com/checkpoint-restore/criu/criu-dev/criu/include/magic.h -o magic.h

test:
	@echo "Running unit test"
	$(GO) test -v
	@echo "Running E2E test"
	@./magicgen-test.sh
	@rm -f input.h output.go expected.go

clean:
	rm -f ../magic/magic.go magic.h

.PHONY: magic-gen test clean

=== test/Makefile ===
SHELL = /bin/bash
GO ?= go
CC ?= gcc
COVERAGE_PATH ?= $(shell pwd)/.coverage
CRIU_FEATURE_MEM_TRACK = $(shell if criu check --feature mem_dirty_track > /dev/null; then echo 1; else echo 0; fi)
CRIU_FEATURE_LAZY_PAGES = $(shell if criu check --feature uffd-noncoop > /dev/null; then echo 1; else echo 0; fi)
CRIU_FEATURE_PIDFD_STORE = $(shell if criu check --feature pidfd_store > /dev/null; then echo 1; else echo 0; fi)

export CRIU_FEATURE_MEM_TRACK CRIU_FEATURE_LAZY_PAGES CRIU_FEATURE_PIDFD_STORE

TEST_PAYLOAD := piggie/piggie
TEST_BINARIES := test $(TEST_PAYLOAD) phaul/phaul
COVERAGE_BINARIES := test.coverage phaul/phaul.coverage

all: $(TEST_BINARIES) phaul-test
	mkdir -p image
	PID=$$(piggie/piggie) && { \
	test dump $$PID image && \
	test restore image; \
	pkill -9 piggie; \
	}
	rm -rf image

piggie/piggie: piggie/piggie.c
	$(CC) $^ -o $@

test: main.go
	$(GO) build -v -o $@ $^

phaul/phaul: phaul/main.go
	$(GO) build -v -o $@ $^

phaul-test: $(TEST_BINARIES)
	rm -rf image
	PID=$$(piggie/piggie) && { \
	phaul/phaul $$PID; \
	pkill -9 piggie; \
	}

crit-test:
	$(MAKE) -C crit

test.coverage: *.go
	$(GO) test \
		-covermode=count \
		-coverpkg=./... \
		-mod=vendor \
		-tags coverage \
		-buildmode=pie -c -o $@ $^

phaul/phaul.coverage: phaul/*.go
	$(GO) test \
		-covermode=count \
		-coverpkg=./... \
		-mod=vendor \
		-tags coverage \
		-buildmode=pie -c -o $@ $^

coverage: $(COVERAGE_BINARIES) $(TEST_PAYLOAD)
	mkdir -p $(COVERAGE_PATH)
	mkdir -p image
	PID=$$(piggie/piggie) && { \
	./test.coverage -test.coverprofile=coverprofile.integration.$$RANDOM -test.outputdir=${COVERAGE_PATH} COVERAGE dump $$PID image && \
	./test.coverage -test.coverprofile=coverprofile.integration.$$RANDOM -test.outputdir=${COVERAGE_PATH} COVERAGE restore image; \
	pkill -9 piggie; \
	}
	rm -rf image
	PID=$$(piggie/piggie) && { \
	phaul/phaul.coverage -test.coverprofile=coverprofile.integration.$$RANDOM -test.outputdir=${COVERAGE_PATH} COVERAGE $$PID; \
	pkill -9 piggie; \
	}
	echo "mode: set" > .coverage/coverage.out && cat .coverage/coverprofile* | \
		grep -v mode: | sort -r | awk '{if($$1 != last) {print $$0;last=$$1}}' >> .coverage/coverage.out

codecov:
	curl -Os https://uploader.codecov.io/latest/linux/codecov
	chmod +x codecov
	./codecov -f '.coverage/coverage.out'

clean:
	@rm -f $(TEST_BINARIES) $(COVERAGE_BINARIES) codecov
	@rm -rf image $(COVERAGE_PATH)

.PHONY: all clean coverage codecov crit-test phaul-test

=== test/crit/Makefile ===
CC ?= gcc
GO ?= go
CRIU ?= criu

all: unit-test integration-test e2e-test clean

unit-test: test-imgs
	go test -v ./...

integration-test: test-imgs crit-test
	@echo "Running integration test"
	@./crit-test

e2e-test: ../../crit/bin/crit test-imgs crit-test.sh
	@echo "Running E2E test"
	@./crit-test.sh

test-imgs: ../loop/loop
	$(eval PID := $(shell ../loop/loop))
	mkdir -p $@
	$(CRIU) dump -v4 -o dump.log -D $@ -t $(PID)
	$(CRIU) restore -v4 -o restore.log -D $@ -d
	pkill -9 loop

../../crit/bin/crit:
	$(MAKE) -C ../../crit bin/crit

../loop/loop: ../loop/loop.c
	$(CC) $^ -o $@

crit-test: main.go
	$(GO) build -v -o $@ $^

clean:
	@rm -rf test-imgs

.PHONY: all test unit-test integration-test e2e-test clean

=== debian/control ===
--- 
+++ 
@@ -2,17 +2,19 @@
 Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
 Uploaders:
  Dmitry Smirnov <onlyjob@debian.org>,
-Section: devel
+ Reinhard Tartler <siretart@tauware.de>
+Section: golang
 Testsuite: autopkgtest-pkg-go
 Priority: optional
 Build-Depends:
  debhelper-compat (= 13),
  dh-golang,
+ golang-github-spf13-cobra-dev,
  golang-google-protobuf-dev,
  protoc-gen-go,
 Build-Depends-Indep:
  golang-any,
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-github-checkpoint-restore-go-criu
 Vcs-Git: https://salsa.debian.org/go-team/packages/golang-github-checkpoint-restore-go-criu.git
 Homepage: https://github.com/checkpoint-restore/go-criu
@@ -26,6 +28,7 @@
  ${misc:Depends},
 Breaks:
  golang-github-opencontainers-runc-dev (<< 1.0.2+ds1-1~),
+Multi-Arch: foreign
 Description: CRIU bindings for Golang
  Golang bindings for CRIU. The code is based on the Golang-based PHaul
  implementation from the CRIU repository.

=== debian/rules ===
--- 
+++ 
@@ -12,3 +12,7 @@
 	$(RM) $(addprefix $(SRC_DIR),rpc/rpc.pb.go stats/stats.pb.go)
 	cd $(SRC_DIR) && protoc --go_out=. --go_opt=Mrpc/rpc.proto=rpc/ rpc/rpc.proto
 	cd $(SRC_DIR) && protoc --go_out=. --go_opt=Mstats/stats.proto=stats/ stats/stats.proto
+
+override_dh_auto_install:
+	dh_auto_install -- --no-binaries
+	find _build debian -name '*.proto' -exec chmod -x {} +

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none, dversionmangle=s/\+ds\d*$//, repacksuffix=+ds1" \
  https://github.com/checkpoint-restore/go-criu \
  refs/tags/v?@ANY_VERSION@ debian

## golang-github-checkpoint-restore-go-criu 7.1.0+ds1

=== test/Makefile ===
SHELL = /bin/bash
GO ?= go
CC ?= gcc
COVERAGE_PATH ?= $(shell pwd)/.coverage
CRIU_FEATURE_MEM_TRACK = $(shell if criu check --feature mem_dirty_track > /dev/null; then echo 1; else echo 0; fi)
CRIU_FEATURE_LAZY_PAGES = $(shell if criu check --feature uffd-noncoop > /dev/null; then echo 1; else echo 0; fi)
CRIU_FEATURE_PIDFD_STORE = $(shell if criu check --feature pidfd_store > /dev/null; then echo 1; else echo 0; fi)

export CRIU_FEATURE_MEM_TRACK CRIU_FEATURE_LAZY_PAGES CRIU_FEATURE_PIDFD_STORE

TEST_PAYLOAD := piggie/piggie
TEST_BINARIES := test $(TEST_PAYLOAD) phaul/phaul
COVERAGE_BINARIES := test.coverage phaul/phaul.coverage crit/crit-test.coverage

GO_MAJOR_VER = $(shell $(GO) version | cut -c 14- | cut -d' ' -f1 | cut -d'.' -f1)
GO_MINOR_VER = $(shell $(GO) version | cut -c 14- | cut -d' ' -f1 | cut -d'.' -f2)
MIN_GO_MAJOR_VER = 1
MIN_GO_MINOR_VER = 20
GO_VALIDATION_ERR = Go version is not supported. Please update to at least $(MIN_GO_MAJOR_VER).$(MIN_GO_MINOR_VER)

all: $(TEST_BINARIES) phaul-test
	mkdir -p image
	PID=$$(piggie/piggie) && \
	trap 'pkill -9 piggie' INT EXIT TERM && \
	./test dump $$PID image && \
	./test restore image
	rm -rf image

check-go-version:
	@if [ $(GO_MAJOR_VER) -gt $(MIN_GO_MAJOR_VER) ]; then \
		exit 0 ;\
	elif [ $(GO_MAJOR_VER) -lt $(MIN_GO_MAJOR_VER) ]; then \
		echo '$(GO_VALIDATION_ERR)';\
		exit 1; \
	elif [ $(GO_MINOR_VER) -lt $(MIN_GO_MINOR_VER) ] ; then \
		echo '$(GO_VALIDATION_ERR)';\
		exit 1; \
	fi

piggie/piggie: piggie/piggie.c
	$(CC) $^ -o $@

test: main.go
	$(GO) build -v -o $@ $^

phaul/phaul: phaul/main.go
	$(GO) build -v -o $@ $^

phaul-test: $(TEST_BINARIES)
	rm -rf image
	PID=$$(piggie/piggie) && \
	trap 'pkill -9 piggie' INT EXIT TERM && \
	phaul/phaul $$PID

crit-test:
	$(MAKE) -C crit

test.coverage: check-go-version *.go
	$(GO) build \
		-cover \
		-o $@ main.go

phaul/phaul.coverage: check-go-version phaul/*.go
	$(GO) build \
		-cover \
		-o $@ phaul/main.go

crit/crit-test.coverage: check-go-version crit/*.go
	# Re-build the crit binary, so that test coverage
	# works even if we run `make test` before that.
	$(MAKE) -C ../crit clean
	$(MAKE) -C ../crit bin/crit GOFLAGS="-cover"
	$(MAKE) -C crit/ test-imgs
	$(GO) build \
		-cover \
		-o $@ crit/main.go

coverage: check-go-version $(COVERAGE_BINARIES) $(TEST_PAYLOAD)
	mkdir -p $(COVERAGE_PATH)
	mkdir -p image
	PID=$$(piggie/piggie) && \
	trap 'pkill -9 piggie' INT EXIT TERM && \
	GOCOVERDIR=${COVERAGE_PATH} ./test.coverage dump $$PID image && \
	GOCOVERDIR=${COVERAGE_PATH} ./test.coverage restore image
	rm -rf image
	PID=$$(piggie/piggie) && \
	trap 'pkill -9 piggie' INT EXIT TERM && \
	GOCOVERDIR=${COVERAGE_PATH} phaul/phaul.coverage $$PID
	cd crit/ && GOCOVERDIR=${COVERAGE_PATH} ./crit-test.coverage
	$(MAKE) -C ../crit/ unit-test GOFLAGS="-coverprofile=${COVERAGE_PATH}/coverprofile-crit-unit-test"
	$(MAKE) -C crit/ e2e-test GOCOVERDIR=${COVERAGE_PATH}
	$(MAKE) -C crit/ clean
	# Generate coverage for ../scripts/magic-gen
	$(MAKE) -C ../scripts/magic-gen test GOFLAGS="-coverprofile=${COVERAGE_PATH}/coverprofile-scripts-unit-test" GOCOVERDIR="${COVERAGE_PATH}"
	# Print coverage from this run
	$(GO) tool covdata percent -i=${COVERAGE_PATH}
	$(GO) tool covdata textfmt -i=${COVERAGE_PATH} -o ${COVERAGE_PATH}/coverage.out
	# The coverage from 'go test' is stored in coverprofile-*,
	# but we upload only 'coverage.out' with codecov. Here we
	# combine the coverage results to show up in GitHub.
	cat .coverage/coverprofile* | \
		grep -v mode: | sort -r | awk '{if($$1 != last) {print $$0;last=$$1}}' >> ${COVERAGE_PATH}/coverage.out
	# We do not want to upload coverage for autogenerated files (*.pb.go)
	sed -i '/\.pb\.go/d' ${COVERAGE_PATH}/coverage.out

codecov:
	curl -Os https://uploader.codecov.io/latest/linux/codecov
	chmod +x codecov
	./codecov -f "$(COVERAGE_PATH)/coverage.out"

clean:
	@rm -f $(TEST_BINARIES) $(COVERAGE_BINARIES) codecov
	@rm -rf image $(COVERAGE_PATH)
	@make -C crit/ clean
	@make -C loop/ clean
	@make -C mmapper/ clean

.PHONY: all clean coverage codecov crit-test phaul-test check-go-version

=== scripts/magic-gen/Makefile ===
GO ?= go

MAGIC_DEST ?= ../../magic/magic.go

magic-gen: clean magic.h
	$(GO) run magicgen.go magic.h $(MAGIC_DEST)

magic.h:
	curl -s https://raw.githubusercontent.com/checkpoint-restore/criu/criu-dev/criu/include/magic.h -o magic.h

test:
	@echo "Running unit test"
	$(GO) test -v
	@echo "Running E2E test"
	@./magicgen-test.sh
	@rm -f input.h output.go expected.go

clean:
	rm -f $(MAGIC_DEST) magic.h

.PHONY: magic-gen test clean

=== debian/changelog ===
golang-github-checkpoint-restore-go-criu (7.1.0+ds1-6) unstable; urgency=medium

  * Upload to unstable.

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 17 Aug 2024 07:16:05 -0400

golang-github-checkpoint-restore-go-criu (7.1.0+ds1-5) experimental; urgency=medium

  * Fix typo in Breaks declaration

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 10 Aug 2024 06:21:55 -0400

golang-github-checkpoint-restore-go-criu (7.1.0+ds1-4) experimental; urgency=medium

  * Add Breaks: golang-github-checkpoint-restore-checkpointctl-dev

 -- Reinhard Tartler <siretart@tauware.de>  Fri, 09 Aug 2024 16:53:59 -0400

golang-github-checkpoint-restore-go-criu (7.1.0+ds1-3) experimental; urgency=medium

  * Reupload.

 -- Reinhard Tartler <siretart@tauware.de>  Thu, 08 Aug 2024 22:35:58 -0400

golang-github-checkpoint-restore-go-criu (7.1.0+ds1-2) experimental; urgency=medium

  * Tighten Breaks on golang-github-opencontainers-runc-dev
  * Bump Standards-Version
  * normalize fields with wrap-and-sort
  * add breaks on lxd, incus

 -- Reinhard Tartler <siretart@tauware.de>  Thu, 08 Aug 2024 13:54:32 -0400

golang-github-checkpoint-restore-go-criu (7.1.0+ds1-1) experimental; urgency=medium

  * New upstream release
  * Skip Image tests that require generated criu test images

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 06 Aug 2024 20:06:42 -0400

=== debian/control ===
Source: golang-github-checkpoint-restore-go-criu
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Dmitry Smirnov <onlyjob@debian.org>,
           Reinhard Tartler <siretart@tauware.de>
Section: golang
Testsuite: autopkgtest-pkg-go
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-golang,
               golang-github-spf13-cobra-dev,
               golang-google-protobuf-dev,
               protoc-gen-go
Build-Depends-Indep: golang-any
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-github-checkpoint-restore-go-criu
Vcs-Git: https://salsa.debian.org/go-team/packages/golang-github-checkpoint-restore-go-criu.git
Homepage: https://github.com/checkpoint-restore/go-criu
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/checkpoint-restore/go-criu

Package: golang-github-checkpoint-restore-go-criu-dev
Architecture: all
Depends: golang-google-protobuf-dev, ${misc:Depends}
Breaks: golang-github-checkpoint-restore-checkpointctl-dev (<< 1.2.1+ds1-3~),
        incus (<< 6.0.1-2),
        golang-github-opencontainers-runc-dev (<< 1.1.12+ds1-4~),
        lxd (<< 5.0.2+git20231211.1364ae4-6)
Multi-Arch: foreign
Description: CRIU bindings for Golang
 Golang bindings for CRIU. The code is based on the Golang-based PHaul
 implementation from the CRIU repository.
 .
 Golang bindings provide an easy way to use the CRIU RPC calls from Golang
 without the need to set up all the infrastructure to make the actual RPC
 connection to CRIU.

## golang-github-checkpoint-restore-go-criu 7.2.0%2Bds1

=== debian/tests/control ===
Tests: integration-tests
Depends: criu (>= 3.19), @, @builddeps@, @recommends@, procps
Restrictions: allow-stderr, needs-root, isolation-machine, flaky

## golang-github-checkpoint-restore-go-criu 7.2.0+ds1

=== crit/Makefile ===
GO ?= go
CRIU ?= criu
CRIT_SRC := $(shell find . -type f -name '*.go')
CRIT_CLI := cmd/main.go

bin/crit: $(CRIT_SRC)
	$(GO) build ${GOFLAGS} -o $@ $(CRIT_CLI)

../test/loop/loop:
	$(MAKE) -C ../test/loop

test-imgs: ../test/loop/loop
	$(eval PID := $(shell ../test/loop/loop))
	mkdir -p $@
	$(CRIU) dump -v4 -o dump.log -D $@ -t $(PID)
	$(CRIU) restore -v4 -o restore.log -D $@ -d
	pkill -9 loop

unit-test: test-imgs
	$(eval GOFLAGS ?= -cover)
	$(GO) test ${GOFLAGS} -v ./...

clean:
	@rm -f bin/crit
	@rm -rf test-imgs

.PHONY: unit-test clean

=== test/Makefile ===
--- 
+++ 
@@ -12,12 +12,6 @@
 TEST_BINARIES := test $(TEST_PAYLOAD) phaul/phaul
 COVERAGE_BINARIES := test.coverage phaul/phaul.coverage crit/crit-test.coverage
 
-GO_MAJOR_VER = $(shell $(GO) version | cut -c 14- | cut -d' ' -f1 | cut -d'.' -f1)
-GO_MINOR_VER = $(shell $(GO) version | cut -c 14- | cut -d' ' -f1 | cut -d'.' -f2)
-MIN_GO_MAJOR_VER = 1
-MIN_GO_MINOR_VER = 20
-GO_VALIDATION_ERR = Go version is not supported. Please update to at least $(MIN_GO_MAJOR_VER).$(MIN_GO_MINOR_VER)
-
 all: $(TEST_BINARIES) phaul-test
 	mkdir -p image
 	PID=$$(piggie/piggie) && \
@@ -25,17 +19,6 @@
 	./test dump $$PID image && \
 	./test restore image
 	rm -rf image
-
-check-go-version:
-	@if [ $(GO_MAJOR_VER) -gt $(MIN_GO_MAJOR_VER) ]; then \
-		exit 0 ;\
-	elif [ $(GO_MAJOR_VER) -lt $(MIN_GO_MAJOR_VER) ]; then \
-		echo '$(GO_VALIDATION_ERR)';\
-		exit 1; \
-	elif [ $(GO_MINOR_VER) -lt $(MIN_GO_MINOR_VER) ] ; then \
-		echo '$(GO_VALIDATION_ERR)';\
-		exit 1; \
-	fi
 
 piggie/piggie: piggie/piggie.c
 	$(CC) $^ -o $@
@@ -55,17 +38,17 @@
 crit-test:
 	$(MAKE) -C crit
 
-test.coverage: check-go-version *.go
+test.coverage: *.go
 	$(GO) build \
 		-cover \
 		-o $@ main.go
 
-phaul/phaul.coverage: check-go-version phaul/*.go
+phaul/phaul.coverage: phaul/*.go
 	$(GO) build \
 		-cover \
 		-o $@ phaul/main.go
 
-crit/crit-test.coverage: check-go-version crit/*.go
+crit/crit-test.coverage: crit/*.go
 	# Re-build the crit binary, so that test coverage
 	# works even if we run `make test` before that.
 	$(MAKE) -C ../crit clean
@@ -75,7 +58,7 @@
 		-cover \
 		-o $@ crit/main.go
 
-coverage: check-go-version $(COVERAGE_BINARIES) $(TEST_PAYLOAD)
+coverage: $(COVERAGE_BINARIES) $(TEST_PAYLOAD)
 	mkdir -p $(COVERAGE_PATH)
 	mkdir -p image
 	PID=$$(piggie/piggie) && \
@@ -103,16 +86,11 @@
 	# We do not want to upload coverage for autogenerated files (*.pb.go)
 	sed -i '/\.pb\.go/d' ${COVERAGE_PATH}/coverage.out
 
-codecov:
-	curl -Os https://uploader.codecov.io/latest/linux/codecov
-	chmod +x codecov
-	./codecov -f "$(COVERAGE_PATH)/coverage.out"
-
 clean:
-	@rm -f $(TEST_BINARIES) $(COVERAGE_BINARIES) codecov
+	@rm -f $(TEST_BINARIES) $(COVERAGE_BINARIES)
 	@rm -rf image $(COVERAGE_PATH)
 	@make -C crit/ clean
 	@make -C loop/ clean
 	@make -C mmapper/ clean
 
-.PHONY: all clean coverage codecov crit-test phaul-test check-go-version
+.PHONY: all clean coverage crit-test phaul-test

=== scripts/magic-gen/Makefile ===
PY ?= python3

MAGIC_DEST ?= ../../magic/magic.go

magic-gen: clean magic.h magicgen.py
	@$(PY) magicgen.py magic.h $(MAGIC_DEST)

magic.h:
	curl -s https://raw.githubusercontent.com/checkpoint-restore/criu/criu-dev/criu/include/magic.h -o magic.h

test: test_magicgen.py magicgen-test.sh
	@echo "Running unit tests..."
	@$(PY) test_magicgen.py
	@echo "Running E2E tests..."
	@./magicgen-test.sh
	@rm -f input.h output.go expected.go

clean:
	rm -f $(MAGIC_DEST) magic.h

.PHONY: magic-gen test clean

=== scripts/proto-gen/Makefile ===
PY ?= python3
PROTO_PATH ?= ../../crit/images
PB_PATH ?= ../../crit/images
GIT_BRANCH ?= master

pb-gen: clean-pb
	@$(PY) protogen.py $(PROTO_PATH) $(PB_PATH)

proto-update: clean-proto
	git clone --depth 1 --branch $(GIT_BRANCH) https://github.com/checkpoint-restore/criu criu-temp
	cp criu-temp/images/*.proto $(PROTO_PATH)/
	# rpc.proto is not an image and it is used only to communicate criu-service and swrk.
	rm -rf criu-temp $(PROTO_PATH)/rpc.proto
	# To prevent namespace conflict with proto files
	# in github.com/letsencrypt/boulder, we prepend
	# a prefix to the filenames.
	mv $(PROTO_PATH)/sa.proto $(PROTO_PATH)/criu-sa.proto
	sed -i 's/sa\.proto/criu-sa\.proto/g' $(PROTO_PATH)/*.proto
	mv $(PROTO_PATH)/core.proto $(PROTO_PATH)/criu-core.proto
	sed -i 's/core\.proto/criu-core\.proto/g' $(PROTO_PATH)/*.proto

clean-proto:
	@echo "Removing existing .proto files..."
	rm $(PROTO_PATH)/*.proto || true

clean-pb:
	@echo "Removing existing .pb.go files..."
	find $(PB_PATH) -type f -name '*.pb.go' -delete

.PHONY: pb-gen proto-update clean-proto clean-pb

=== test/crit/Makefile ===
GO ?= go
CRIU ?= criu

all: integration-test e2e-test clean

integration-test: test-imgs crit-test
	@echo "Running integration test"
	@./crit-test

e2e-test: ../../crit/bin/crit test-imgs crit-test.sh
	@echo "Running E2E test"
	@./crit-test.sh

# gen_mmapper_imgs generates CRIU images for mmapper process.
# Parameters:
#   $(1) - Memory size for memory mapping.
#   $(2) - Mmap flags: p - private, s - shared, a - anonymous.
#   $(3) - Directory where the generated images and information will be saved.
define gen_mmapper_imgs
	$(eval MM_PID := $(shell ../mmapper/mmapper $(1) $(2) "/tmp/mmapper-${1}-${2}.log"))
	$(eval MM_DIR := $(3))
	mkdir -p $(MM_DIR)
	cp /proc/$(MM_PID)/environ $(MM_DIR)
	cp /proc/$(MM_PID)/cmdline $(MM_DIR)
	$(CRIU) dump -v4 -o dump.log -D $(MM_DIR) -t $(MM_PID)
endef

test-imgs: ../loop/loop ../mmapper/mmapper
	$(eval LOOP_PID := $(shell ../loop/loop))
	$(eval LOOP_DIR := $@/loop)
	mkdir -p ${LOOP_DIR}
	cp /proc/${LOOP_PID}/environ ${LOOP_DIR}
	cp /proc/${LOOP_PID}/cmdline ${LOOP_DIR}
	$(CRIU) dump -v4 -o dump.log -D ${LOOP_DIR} -t $(LOOP_PID)

	# Generate mmapper CRIU images for different memory mapping scenarios.
	# gen_mmapper_imgs <memory size> <mmap flags> <images dir>
	$(call gen_mmapper_imgs, 257, p, $@/mm_p_257b)
	$(call gen_mmapper_imgs, 257, pa, $@/mm_pa_257b)
	$(call gen_mmapper_imgs, 257, s, $@/mm_s_257b)
	$(call gen_mmapper_imgs, 257, sa, $@/mm_sa_257b)
	$(call gen_mmapper_imgs, 4096, p, $@/mm_p_4kb)
	$(call gen_mmapper_imgs, 4096, pa, $@/mm_pa_4kb)
	$(call gen_mmapper_imgs, 4096, s, $@/mm_s_4kb)
	$(call gen_mmapper_imgs, 4096, sa, $@/mm_sa_4kb)
	$(call gen_mmapper_imgs, 32768, p, $@/mm_p_32kb)
	$(call gen_mmapper_imgs, 32768, pa, $@/mm_pa_32kb)
	$(call gen_mmapper_imgs, 32768, s, $@/mm_s_32kb)
	$(call gen_mmapper_imgs, 32768, sa, $@/mm_sa_32kb)

../../crit/bin/crit:
	$(MAKE) -C ../../crit bin/crit GOFLAGS="${GOFLAGS}"

../loop/loop:
	$(MAKE) -C ../loop

../mmapper/mmapper:
	$(MAKE) -C ../mmapper

crit-test: main.go
	$(GO) build -v -o $@ $^

clean:
	@rm -rf test-imgs crit-test /tmp/mmapper-*.log

.PHONY: all test integration-test e2e-test clean

=== test/loop/Makefile ===
CC ?= gcc

loop: loop.c
	$(CC) $^ -o $@

clean:
	@rm -f loop

.PHONY: clean

=== test/mmapper/Makefile ===
CC ?= gcc

mmapper: mmapper.c
	$(CC) $^ -o $@

clean:
	@rm -f mmapper

.PHONY: clean

=== debian/changelog ===
golang-github-checkpoint-restore-go-criu (7.2.0+ds1-4) unstable; urgency=medium

  * Mark autopkgtest to require qemu

 -- Reinhard Tartler <siretart@tauware.de>  Mon, 18 Nov 2024 20:18:59 -0500

golang-github-checkpoint-restore-go-criu (7.2.0+ds1-3) unstable; urgency=medium

  * Mark test as working without qemu
  * upload to unstable

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 12 Nov 2024 09:47:14 -0500

golang-github-checkpoint-restore-go-criu (7.2.0+ds1-2) unstable; urgency=medium

  * fix golang import path
  * autopkgtests: Tighten dependency on criu, mark test as non-flaky

 -- Reinhard Tartler <siretart@tauware.de>  Mon, 04 Nov 2024 18:53:54 -0500

golang-github-checkpoint-restore-go-criu (7.2.0+ds1-1) experimental; urgency=medium

  * New upstream release: 7.2.0

 -- Reinhard Tartler <siretart@tauware.de>  Mon, 28 Oct 2024 08:36:47 -0400

=== debian/control ===
--- 
+++ 
@@ -16,14 +16,14 @@
 Vcs-Git: https://salsa.debian.org/go-team/packages/golang-github-checkpoint-restore-go-criu.git
 Homepage: https://github.com/checkpoint-restore/go-criu
 Rules-Requires-Root: no
-XS-Go-Import-Path: github.com/checkpoint-restore/go-criu
+XS-Go-Import-Path: github.com/checkpoint-restore/go-criu/v7
 
 Package: golang-github-checkpoint-restore-go-criu-dev
 Architecture: all
 Depends: golang-google-protobuf-dev, ${misc:Depends}
 Breaks: golang-github-checkpoint-restore-checkpointctl-dev (<< 1.2.1+ds1-3~),
+        golang-github-opencontainers-runc-dev (<< 1.1.12+ds1-4~),
         incus (<< 6.0.1-2),
-        golang-github-opencontainers-runc-dev (<< 1.1.12+ds1-4~),
         lxd (<< 5.0.2+git20231211.1364ae4-6)
 Multi-Arch: foreign
 Description: CRIU bindings for Golang

=== debian/rules ===
--- 
+++ 
@@ -1,8 +1,8 @@
 #!/usr/bin/make -f
 
-export DH_GOLANG_EXCLUDES := crit-go/magic-gen phaul test
+export DH_GOLANG_EXCLUDES := crit-go/magic-gen test
 
-SRC_DIR = _build/src/github.com/checkpoint-restore/go-criu/
+SRC_DIR = _build/src/github.com/checkpoint-restore/go-criu/v7/
 
 %:
 	dh $@ --builddirectory=_build --buildsystem=golang --with=golang

=== debian/tests/control ===
Tests: integration-tests
Depends: criu (>= 3.19), @, @builddeps@, @recommends@, procps
Restrictions: allow-stderr, needs-root, isolation-machine
